@echo off
bin\adb.exe disconnect

setlocal EnableDelayedExpansion

SET _VERSION_=3.1.8

ECHO =========================================================================================
ECHO   WorldVDS Generic Android Installer v%_VERSION_%
ECHO =========================================================================================
ECHO.



call :count_devices

IF %_COUNT_% EQU 0 (
    call bin\connect.cmd
)

ECHO.
bin\adb.exe devices
ECHO.

FOR /F "tokens=1,2" %%a IN ('bin\adb.exe devices') DO (
    IF "%%b" == "device" (		
		call :install %%a								
        call :permitions %%a		
		call :clean %%a				        		
    )
)

pause
GOTO :eof

:count_devices
    SET _COUNT_=0
    FOR /F "tokens=1,2" %%a IN ('bin\adb.exe devices') DO (
        IF "%%b" == "device" (
	        SET /A _COUNT_=%_COUNT_%+1
        )
    )
GOTO :eof

:clean
    IF "%1" == "" (
        ECHO Error: No device specified.
        ECHO.
        GOTO :eof
    )

    FOR /F "tokens=*" %%A in (bin\remove.txt) DO (
        ECHO Uninstalling %%A on Device %1		
        bin\adb -s %1 shell pm uninstall --user 0 %%A	
    )
	
GOTO :eof

:install
    IF "%1" == "" (
        ECHO Error: No device specified.
        ECHO.
        GOTO :eof
    )

    IF NOT EXIST APK\ (
        ECHO Error: APK folder not found.
        ECHO.
        GOTO :eof
    )    	
	ECHO Please wait for instalation ...	
    FOR /F %%A IN ('DIR /B APK\*.apk') DO (	
        ECHO Upload %%A on Device %1
		bin\adb -s %1 push APK\%%A /data/local/tmp/				
		bin\adb -s %1 shell settings put global package_verifier_user_consent -1
        bin\adb -s %1 shell pm install -t /data/local/tmp/%%A
    )
GOTO :eof

:permitions
    IF "%1" == "" (
        ECHO Error: No device specified.
        ECHO.
        GOTO :eof
    )

    ECHO Disabling Power Options	
    bin\adb -s %1 shell settings put system screen_off_timeout 2147483630
    bin\adb -s %1 shell settings put global stay_on_while_plugged_in 1
    bin\adb -s %1 shell settings put secure sleep_timeout -1
    bin\adb -s %1 shell settings put secure screensaver_enabled 0
    bin\adb -s %1 shell settings put secure lockscreen.disabled 1
    bin\adb -s %1 shell settings put global hdmi_control_enabled 0		
    IF EXIST APK\AnyDesk_Custom*.apk (
        ECHO Disabling Battery Optimization for AnyDesk on Device %1
        adb -s %1 shell dumpsys deviceidle whitelist +com.anydesk.adcontrol.ad1
        ::adb -s %1 shell dumpsys deviceidle whitelist +com.anydesk.adcontrol.aosp2
        adb -s %1 shell dumpsys deviceidle whitelist +com.anydesk.anydeskandroid.custom

        ECHO Setting AnyDesk Permissions on Device %1
        adb -s %1 shell appops set com.anydesk.anydeskandroid.custom PROJECT_MEDIA allow
        adb -s %1 shell appops set com.anydesk.anydeskandroid.custom SYSTEM_ALERT_WINDOW allow

        IF EXIST Android_%ANDROID_VER%\adcontrol-ad1.apk (
            ECHO Enabling Accessibility Services to AnyDesk AD1 Plugin
            adb -s %1 shell settings put secure enabled_accessibility_services com.anydesk.adcontrol.ad1/com.anydesk.adcontrol.AccService
        )
        ::adb -s %1 shell dpm set-active-admin com.anydesk.anydeskandroid.custom/com.anydesk.anydeskandroid.adcontrol.AdDeviceAdminReceiver
        ECHO.
    )	
    ECHO Setting Watchdog Permissions on Device %1	
    bin\adb shell appops set com.worldvds.watchdog PROJECT_MEDIA allow
	bin\adb shell appops set com.worldvds.watchdog SYSTEM_ALERT_WINDOW allow
	bin\adb shell appops set com.worldvds.watchdog REQUEST_INSTALL_PACKAGES allow
	bin\adb shell appops set com.worldvds.watchdog WRITE_SETTINGS allow		
	echo bin\adb shell dpm set-active-admin com.worldvds.watchdog/.MyAdminReceiver	
	bin\adb -s %1 shell pm uninstall --user 0 com.google.android.gms	
	bin\adb -s %1 shell pm remove-user 10	
	bin\adb shell dpm set-device-owner com.worldvds.watchdog/.MyAdminReceiver
	bin\adb shell am start -n com.worldvds.watchdog/com.worldvds.watchdog.MainActivity
	ECHO.	
GOTO :eof
